unit Unit1;
{
  24.02.98, RH.
  Very simple Oleander demo application.
  Shows the basics in printing with Oleander.

  !!
  This demo defaults to an english Word7.
  The code that has to be changed is not compilable at first, and has to be
  adapted if necessary. The comments should make that clear.

  The default printer is used, but may be modified in the appropriate property.
  !!
}

interface

uses
  ComObj,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, ComCtrls, StdCtrls, Buttons,
  OleanderAuto, OleanderPrinter, OleanderWord7, OleanderWord8, OleanderController,
  OleanderException,    // added manually
  OleanderIdentifier,   // added manually
  OleanderTools;        // added manually

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    StatusBar1: TStatusBar;
    OleanderController1: TOleanderController;
    OleanderWord71: TOleanderWord7;  // No new Word release, just Delphi's automatic names
    OleanderWord81: TOleanderWord8;
    Table1: TTable;
    DataSource1: TDataSource;
    Table1NAME: TStringField;
    Table1SIZE: TSmallintField;
    Table1WEIGHT: TSmallintField;
    Table1AREA: TStringField;
    Table1BMP: TBlobField; // !! Notice: Blobtype switched to ftGraphic, to be recognized by Oleander
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure OleanderController1AfterPrintField(Sender: TObject;
      AIdentifier: TOleanderIdentifier; ADatasource: TDataSource);
    procedure OleanderController1AfterPrintRecord(Sender: TObject;
      AIdentifier: TOleanderIdentifier; ADatasource: TDataSource);
  private
    aborted: boolean;
    count: integer;
    records: integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Table1.Open;

// The code below is depending on your Word release and, if you use
// Word7, on the installed language of Word7.
// Set as you need and comment the ones you don't need.

 // if you use Word8
  OleanderController1.OleanderPrinter := OleanderWord81;
//
// if you use Word7
//-> OleanderController1.OleanderPrinter := OleanderWord71;
//-> OleanderWord71.WordBasicDialect := wbdEnglish;  // if you use Word7, set language. See online help or OleanderWord71 component
//  you may comment the above line and set the WordBasicDialect property in the OleanderWord71 component.
//
  OleanderController1.OleanderPrinter.Docname := ExePath + OleanderController1.OleanderPrinter.Docname;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  try  // let's try
    try  // let's try again
      records := Table1.RecordCount;
      aborted := FALSE;  // Reset if second try
      count := 0;        // ditto
      OleanderController1.Open; // OLE server available?
      OleanderController1.OleanderPrinter.ShowServer := TRUE; // to show what we have
      OleanderController1.Print(TRUE); // let go, but preview mode. Don't send to printer
      if MessageDlg('Done! Send document to printer?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        OleanderController1.OleanderPrinter.PrintDoc;
    except  // Damn
      on e: EOleanderError do
      begin
        if e.Error = oerAbort then // User has pressed Abort button
          ShowMessage('Aborted by user!')  // Messagebox may be hidden behind Word
        else                       // Something wrong with Oleander
          ShowMessage(e.message);
      end;
      on e: Exception do ShowMessage(e.message); // Someting completely wrong
    end;
  finally
    OleanderController1.Close;
  end;
end;

procedure TForm1.OleanderController1AfterPrintField(Sender: TObject;
  AIdentifier: TOleanderIdentifier; ADatasource: TDataSource);
//  AfterPrintField event handled for faster Abort response as with AfterPrintRecord
begin
  if aborted then OleanderAbort; // OleanderAbort is found in OleanderTools. Aborted set in OnClick handler of BitBtn2.
  Application.ProcessMessages;   // Keep application alive during print
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  aborted := TRUE;  // Insert your favorite Abort, Retry, Ignore message here!
end;

procedure TForm1.OleanderController1AfterPrintRecord(Sender: TObject;
  AIdentifier: TOleanderIdentifier; ADatasource: TDataSource);
begin
  inc(count);  // will wrap if more than a lot records !
  Statusbar1.SimpleText := 'Record ' + IntToStr(count) + ' of ' + IntToStr(records);
end;

end.
